//----------------------------------------------------------------------------
// CDIBs.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: CDIBs.pas
//----------------------------------------------------------------------------
#ifndef CDIBsHPP
#define CDIBsHPP
//----------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Clipbrd.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Cdibs
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) TDIBImage;
class __declspec(pascalimplementation) TDIBImage : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	int FRefCount;
	Classes::TCustomMemoryStream* FMemoryImage;
	int FWidth;
	int FHeight;
	void *FDIBHeader;
	void *FDIBBits;
	bool FMonochrome;
	void __fastcall Reference(void);
	void __fastcall Release(void);
	void __fastcall FreeHandle(void);
public:
	/* TObject.Create */ __fastcall TDIBImage(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TDIBImage(void) { }
	
};

class __declspec(delphiclass) EDIBError;
class __declspec(pascalimplementation) EDIBError : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EDIBError(const System::AnsiString Msg) : Sysutils::Exception(Msg
		) { }
	/* Exception.CreateFmt */ __fastcall EDIBError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDIBError(int Ident) : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ __fastcall EDIBError(int Ident, const System::TVarRec * Args, const int 
		Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDIBError(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDIBError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EDIBError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDIBError(int Ident, const System::TVarRec * Args, const 
		int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDIBError(void) { }
	
};

class __declspec(delphiclass) TDIB;
class __declspec(pascalimplementation) TDIB : public Graphics::TGraphic
{
	typedef Graphics::TGraphic inherited;
	
private:
	TDIBImage* FImage;
	void __fastcall FreeContext(void);
	void __fastcall AssignFromDIB(TDIB* Source);
	void __fastcall AssignFromClipboard(Clipbrd::TClipboard* Source);
	void __fastcall AssignFromBitmap(Graphics::TBitmap* Source);
	void __fastcall AssignToBitmap(Graphics::TBitmap* Dest);
	void __fastcall InitBIFromBC(tagBITMAPINFOHEADER &BI, tagBITMAPCOREHEADER &BC, int ImageSize);
	void __fastcall NewImage(int NewWidth, int NewHeight, bool NewMonochrome, Classes::TCustomMemoryStream* 
		NewImage, void * NewDIBHeader, void * NewDIBBits);
	void __fastcall ReadStream(long Size, Classes::TStream* Stream);
	void __fastcall WriteStream(Classes::TStream* Stream, bool WriteSize);
	void __fastcall LoadDataFromStream(Classes::TStream* Stream);
	bool __fastcall GetMonochrome(void);
	void __fastcall SetMonochrome(bool Value);
	long __fastcall CopyHeader(Classes::TMemoryStream* Image, int AWidth, int AHeight);
	void __fastcall CopyImage(int ALeft, int ATop, int AWidth, int AHeight, bool AMonochrome, TDIB* Dest
		);
	Windows::PBitmapInfoHeader __fastcall GetHeader(void);
	void * __fastcall GetBits(void);
	void * __fastcall GetColorTable(void);
	int __fastcall GetColorTableSize(void);
	Graphics::TColor __fastcall GetColors(Cardinal Index);
	Word __fastcall GetBitDepth(void);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	virtual HPALETTE __fastcall GetPalette(void);
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect);
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	HPALETTE __fastcall CreateStockPalette(void);
	
public:
	__fastcall virtual TDIB(void);
	__fastcall virtual ~TDIB(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall LoadFromClipboardFormat(Word AFormat, int AData, HPALETTE APalette);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall LoadFromResourceName(int Instance, const System::AnsiString ResName);
	void __fastcall LoadFromResourceID(int Instance, int ResID);
	virtual void __fastcall SaveToClipboardFormat(Word &AFormat, int &AData, HPALETTE &APalette);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall CopySection(int ALeft, int ATop, int AWidth, int AHeight);
	void __fastcall CreateFromSection(TDIB* Src, int ALeft, int ATop, int AWidth, int AHeight);
	bool __fastcall CanConvert16to24(void);
	void __fastcall Convert16to24(void);
	HBITMAP __fastcall DIBToBitmap(HPALETTE Pal);
	__property bool Monochrome = {read=GetMonochrome, write=SetMonochrome, nodefault};
	__property Windows::PBitmapInfoHeader Header = {read=GetHeader, nodefault};
	__property void * Bits = {read=GetBits, nodefault};
	__property void * ColorTable = {read=GetColorTable, nodefault};
	__property int ColorTableSize = {read=GetColorTableSize, nodefault};
	__property Graphics::TColor Colors[Cardinal Index] = {read=GetColors};
	__property Word BitDepth = {read=GetBitDepth, nodefault};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Cdibs */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Cdibs;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// CDIBs
